VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSpeech"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'   Dieser Source stammt von http://www.activevb.de
'   und kann frei verwendet werden. Fr eventuelle Schden
'   wird nicht gehaftet.
'
'   Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'   Ansonsten viel Spa und Erfolg mit diesem Source !

'##################################################
'#  @author: Matthias Bartelt                     #
'#  @info  : DirectSpeech ohne OCX.               #
'##################################################



'##################################################
'#                 DEKLARATIONEN                  #
'##################################################

'Variablen mssen deklariert werden
Option Explicit

'### Konstanten
Private Const cMESSAGE_NOTINITIALIZED As String = "Die DirectSpeech-Engine konnte auf diesem System nicht initialisiert werden."
Private Const cMESSAGE_NOTEXT         As String = "Kein Eingabetext vorhanden."
Private Const cMESSAGE_TITLE          As String = "Fehler:"

'### Variablen
Private oSpeechObject  As Object
Private m_bInitialized As Boolean
Private m_sTextToSpeak As String



'########################################
'#                EVENTS                #
'########################################

'Wenn eine Objektinstanz zum ersten mal geladen wird
Private Sub Class_Initialize()
    
'Process an error
On Error GoTo errError

    'Erstellt ein neues Objekt der Speech API
    Set oSpeechObject = CreateObject("Speech.VoiceText")
    
    'Registriert das Objekt
    Call oSpeechObject.Register("", "cSPEECH_ENGINE")

    'Objekt erfolgreich erzeugt
    m_bInitialized = True

    Exit Sub
    
errError:
    'Zeigt eine Nachricht an (Fehler)
    Call MsgBox(cMESSAGE_NOTINITIALIZED, vbCritical, cMESSAGE_TITLE)
    'Konnte Engine nicht initialisieren
    m_bInitialized = False

End Sub



'########################################
'#                METHODEN              #
'########################################

'Spricht den Text
Public Static Sub sSpeakText(Optional ByVal sText As String)
    
'Programmfehler werden ignoriert
On Error Resume Next

    'Speichert den neuen Text, falls vorhanden
    If Not (Len(sText) = 0) Then m_sTextToSpeak = sText
    
    'Prft, ob die Engine initialisiert wurde
    If (m_bInitialized) Then
        'Prft, ob Text vorhanden ist
        If (Len(m_sTextToSpeak) = 0) Then
            'Zeigt eine Nachricht an (Fehler)
            Call MsgBox(cMESSAGE_NOTEXT, vbCritical, cMESSAGE_TITLE)
        Else
            'Stoppt die letze Aussage
            Call oSpeechObject.StopSpeaking
            'Spricth den Text
            Call oSpeechObject.Speak(m_sTextToSpeak, 1)
        End If
    Else
        'Zeigt eine Nachricht an (Fehler)
        Call MsgBox(cMESSAGE_NOTINITIALIZED, vbCritical, cMESSAGE_TITLE)
    End If
    
End Sub




'########################################
'#              PROPERTIES              #
'########################################

Public Property Get pIsEngineAvailable() As Boolean

    'Gibt den Wert zurck
    pIsEngineAvailable = m_bInitialized

End Property
'########################################
Public Property Get pTextToSpeak() As String

    'Gibt den Wert zurck
    pTextToSpeak = m_sTextToSpeak

End Property

Public Property Let pTextToSpeak(ByVal sNewValue As String)

    'Setzt den neuen Wert
    m_sTextToSpeak = sNewValue

End Property

